/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.hanyo;

import java.security.SecureRandom;
import java.util.List;
import java.util.jar.Attributes;
import org.apache.cayenne.access.DataContext;
import org.apache.cayenne.exp.Expression;
import org.apache.cayenne.exp.ExpressionFactory;
import org.apache.cayenne.query.SelectQuery;
import org.apache.jetspeed.services.logging.JetspeedLogFactoryService;
import org.apache.jetspeed.services.logging.JetspeedLogger;
import org.apache.turbine.util.RunData;
import org.apache.velocity.context.Context;
import com.aimluck.eip.hanyo.util.HanyoUtils;
import com.aimluck.eip.cayenne.om.portlet.ImwMHanyo;
import com.aimluck.eip.common.ALAbstractSelectData;
import com.aimluck.eip.common.ALDBErrorException;
import com.aimluck.eip.common.ALPageNotFoundException;
import com.aimluck.eip.modules.actions.common.ALAction;
import com.aimluck.eip.orm.DatabaseOrmService;
import com.aimluck.eip.util.ALEipUtils;

/**
 * 汎用マスタの検索データを管理するためのクラスです。 <br />
 * 
 */
public class HanyoSelectData extends ALAbstractSelectData {

  /** logger */
  private static final JetspeedLogger logger = JetspeedLogFactoryService
      .getLogger(HanyoSelectData.class.getName());

  /** 現在表示している部署 */
  private String currentPost;

  private int registeredUserNum = 0;

  /**
   * 初期化します。
   * 
   * @see com.aimluck.eip.common.ALAbstractSelectData#init(com.aimluck.eip.modules.actions.common.ALAction,
   *      org.apache.turbine.util.RunData, org.apache.velocity.context.Context)
   */
  public void init(ALAction action, RunData rundata, Context context)
      throws ALPageNotFoundException, ALDBErrorException {

    String sort = ALEipUtils.getTemp(rundata, context, LIST_SORT_STR);
    if (sort == null || sort.equals("")) {
      ALEipUtils.setTemp(rundata, context, LIST_SORT_STR, "hanyo");
    }
    super.init(action, rundata, context);

  }

  /**
   * アカウント一覧を取得します。 ただし、論理削除されているアカウントは取得しません。
   * 
   * @param rundata
   * @param context
   * @return
   * @see com.aimluck.eip.common.ALAbstractSelectData#selectList(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context)
   */
  protected List selectList(RunData rundata, Context context) {
    try {
      // 登録済みのユーザ数をデータベースから取得
      DataContext dataContext = DatabaseOrmService.getInstance()
          .getDataContext();

      SelectQuery query = getSelectQuery(rundata, context);
      
      buildSelectQueryForListView(query);
      buildSelectQueryForListViewSort(query, rundata, context);
      query.addOrdering(ImwMHanyo.PARENT_HANYO_ID_PROPERTY, true);
      query.addOrdering(ImwMHanyo.VALUE_PROPERTY, true);
      
      List list = dataContext.performQuery(query);

      registeredUserNum = list.size();
      return buildPaginatedList(list);
    } catch (Exception ex) {
      logger.error("Exception", ex);
      return null;
    }
  }

  /**
   * 検索条件を設定した SelectQuery を返します。 <BR>
   * 
   * @param rundata
   * @param context
   * @return
   */
  private SelectQuery getSelectQuery(RunData rundata, Context context) {
    SelectQuery query = new SelectQuery(ImwMHanyo.class);

    Expression exp1 = ExpressionFactory.noMatchExp(ImwMHanyo.DISABLED_PROPERTY,
        "T");
    Expression exp2 = ExpressionFactory.noMatchExp(
        ImwMHanyo.PARENT_HANYO_ID_PROPERTY, null);

    query.andQualifier(exp1);
    query.andQualifier(exp2);

    return query;
  }

  /**
   * @param rundata
   * @param context
   * @return
   * @see com.aimluck.eip.common.ALAbstractSelectData#selectDetail(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context)
   */
  protected Object selectDetail(RunData rundata, Context context) {
    return HanyoUtils.getImwMHanyo(rundata, context);
  }

  /**
   * @param obj
   * @return
   * @see com.aimluck.eip.common.ALAbstractSelectData#getResultData(java.lang.Object)
   */
  protected Object getResultData(Object obj) {
    try {

      ImwMHanyo record = (ImwMHanyo) obj;

      HanyoResultData rd = new HanyoResultData();
      rd.initField();

      rd.setHanyoId(record.getHanyoId().intValue());
      rd.setParentHanyoName(HanyoUtils.getParentHanyoName(record
          .getParentHanyoId().intValue()));
      rd.setParentHanyoId(record.getParentHanyoId().intValue());
      rd.setHanyokubunnm(record.getHanyokubunnm());
      rd.setValue(record.getValue());
      rd.setNotDelete(record.getNotDelete());
      rd.setDisabled(record.getDisabled());

      return rd;

    } catch (Exception ex) {
      logger.error("Exception", ex);
      return null;
    }
  }

  /**
   * @param obj
   * @return
   * @see com.aimluck.eip.common.ALAbstractSelectData#getResultDataDetail(java.lang.Object)
   */
  protected Object getResultDataDetail(Object obj) {
    try {
      ImwMHanyo record = (ImwMHanyo) obj;

      Integer id = new Integer(record.getHanyoId());

      HanyoResultData rd = new HanyoResultData();
      rd.initField();

      rd.setHanyoId(Integer.valueOf(record.getHanyoId()).intValue());
      rd.setParentHanyoId(Integer.valueOf(record.getParentHanyoId())
              .intValue());
      rd.setParentHanyoName(HanyoUtils.getParentHanyoName(record
          .getParentHanyoId().intValue()));
      rd.setHanyokubunnm(record.getHanyokubunnm());
      rd.setValue(record.getValue());
      rd.setNotDelete(record.getNotDelete());

      return rd;
    } catch (Exception ex) {
      logger.error("Exception", ex);
      return null;
    }
  }

  /**
   * @return
   * @see com.aimluck.eip.common.ALAbstractSelectData#getColumnMap()
   */
  protected Attributes getColumnMap() {

    Attributes map = new Attributes();

    map.putValue("hanyo_id", "HANYO_ID");
    map.putValue("parent_hanyo_id", ImwMHanyo.PARENT_HANYO_ID_PROPERTY);
    map.putValue("hanyokubunnm", ImwMHanyo.HANYOKUBUNNM_PROPERTY);
    map.putValue("value", ImwMHanyo.VALUE_PROPERTY);
    map.putValue("not_delete", ImwMHanyo.NOT_DELETE_PROPERTY);
    return map;

  }

  /**
   * 登録ユーザー数を取得する．
   * 
   * @return
   */
  public int getRegisteredUserNum() {
    return registeredUserNum;
  }

  public int getRandomNum() {
    SecureRandom random = new SecureRandom();
    return (random.nextInt() * 100);
  }
}
